@echo off
pushd "%~dp0"

if [%1]==[] goto usage
echo Run script "%~n1"

:: Берем аргументы командной строки, которые идут после первого
:: Они будут подставлены при запуске BAS, например --silent
for /f "tokens=1,* delims= " %%a in ("%*") do set ArgumentsAfterFirst=%%b

:: Находим последнюю версию программы в папке apps
for /D %%D in (apps\*) do set appsfolder=%%D

:: Копируем запускаемый проект в файл, который запускается по-умолчанию
::copy /y "%1" "%appsfolder%\project.xml"
:: Если имя скрипта в проекте пустое заменяем его на имя файла
call :replace_string "<ScriptName></ScriptName>" "<ScriptName>%~n1</ScriptName>" "%1" > "%appsfolder%\project.xml"
:: Запускаем BAS
start "" /D "%appsfolder%" "FastExecuteScript.exe" %ArgumentsAfterFirst%
echo Done.
goto :eof

:: Сообщение при запуске без аргументов
:usage
echo Usage: %0 ^<ProjectFile.xml^>
exit /b 1

:: Функция замены строки в файле
:replace_string
for /f "tokens=1,* delims=]" %%A in ('"type %3 | find /n /v """') do (
  set "line=%%B"
  if defined line (
    call set "line=echo.%%line:%~1=%~2%%"
    for /f "delims=" %%X in ('"echo."%%line%%""') do %%~X
  ) else echo.
)
exit /b